<?php

	class Newsletter {
		
		//url du site sur lequel se trouve le module newsletter
		var $url_site				= '';
		//id newsletter courante
		var $id_news				= '';
		//date de parution de la news
		var $date_news				= '';	
		//titre de la newsletter
		var $title_news				= '';
		//url du module de newsletter
		var $url_module				= '';
		//url de l'espace admin de la news
		var $url_admin_news			= '';
		//url courante de la newsletter
		var $url_news				= '';
		//url des images de la newsletter courante
		var $url_img_news			= '';
		
		
		/****************/
		//Format de la news
		var $LARGEUR_NEWS			= '';
		//marge pour mise en plage contenu
		var $LARGEUR_MARGE_NEWS		= '';
		//Format des images
		var $TAILLE_IMG_NEWS		= '';
		/****************/
		
		
		//partie haute de la news contenant les liens pour aperçu en ligne
		var $head_news				= '';
		//corps de la newsletter
		var $body_news				= '';
		//mail de l'administrateur de la newsletter
		var $mail_administrateur	= ADMINISTRATOR_MAIL;
		//mail de l'administrateur des desabonnement
		var $desabonnement_mail		= UNSUBSCRIBE_MAIL;
		
		
		//construction de la base (squelette) d'une newsletter
		function __construct($id_news){
			//dans la nomenclature de la newsletter NLI pour NewsLetterInterne	
			$suffix = '_NLI';
			//nom du dossier dans lequel sont stockées tous les contenus des newsletters
			$dossier_news = "newsletters/";
			
			$this->id_news				= $id_news;
			//url du module de newsletter
			$this->url_module			= URL_NEWSLETTER_MODULE;
			//url des images standard
			$this->url_img_module		= $this->url_module.'img/';
			
			//url des newsletters archivées
			$this->url_news				= $this->url_module.$dossier_news.$this->id_news.$suffix.'/';
			//url des images de la newsletter courante
			$this->url_img_news			= $this->url_news.'img/';
			$this->date_news			= date("d / m / Y");//la date du jour pour un newsjamais en retard ou mal datée dans les e-mails
			$this->title_news			= 'Saisir le titre de la news';
			
			//url de l'accueil admin
			$this->url_admin_news 		= $this->url_module.'admin/';
						
			//Récupération de la liste des articles courant de la newsletter
			
			/*
			$data = $this->Get_Csv($fichier);
			for ($ligne=0;$ligne<count($data);$ligne++){
				if(!$ligne==count($data))
					$bloc .=',';
				$prenom = utf8_encode($data[$ligne][0]);
				$email	= utf8_encode($data[$ligne][1]);
				
				$bloc .= $email;
			}	
			
			$this->liste_de_diffusion = $bloc;
			*/
			

			/****************/
			//Format de la news
			$this->LARGEUR_NEWS = 600;
			
			$this->LARGEUR_MARGE_NEWS = 40;
			//*2 car la marge est à prendre en compte des deux cotés
			//premier 10 correspond au border général de la news (10px)
			//second 10 correspond au paddin et border en plus de l'image (10px)
			$this->TAILLE_IMG_NEWS = $this->LARGEUR_NEWS - ($this->LARGEUR_MARGE_NEWS*2);
			//$this->TAILLE_IMG_NEWS = 520-10;
			/****************/
			
			$this->head = '
					<head>
				        <meta http-equiv="Content-Language" content="fr">
				        <meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
				        <title>'.TITLE_NEWSLETTER.'</title>
				    </head>
				';
			$this->body_news = "Corps de la newsletter";
		}
		
		/*Encapsulage des blocs centrés dans la news en entete*/
		function SetHeaderBloc(){
			$block ='
				<div align="center">
					<center>
						<table style="border-collapse:collapse" border="0" cellpadding="0" cellspacing="0" width="'.$this->LARGEUR_NEWS.'">
							<tr>
								<td height="10"></td>
							</tr>
							<tr>
								<td style="font-size:15px; text-align:center; color:#000; font-family:Arial">
			                     	<b>'.NEWSLETTER_IN_NAME.' : '.$this->title_news.'</b>
								</td>
							</tr>
							<tr>
								<td height="10"></td>
							</tr>
		                </table>
					</center>
				</div> 
			';
			
			return $block;
		}//SetHeaderBloc()
		
		
		/*Encapsulage du bloc d'apercu de la news enligne centrés dans la news en entete*/
		function SetPreviewBloc(){
			$block ='
				<div align="center">
					<center>
						<table style="border-collapse:collapse" border="0" cellpadding="0" cellspacing="0" width="'.$this->LARGEUR_NEWS.'">
							<tr>
								<td height="10"></td>
							</tr>
							<tr>
								<td style="text-align:center; font-size: 11px; color:#555; font-family:Arial">
			                       Si vous ne parvenez pas &agrave; visualiser correctement le message ci-dessous,
								   <a style="color:#F90" href="'.$this->url_news.'newsletter.php?preview='.$this->id_news.'" target="_blank">cliquez ici</a>.
								</td>
							</tr>
							<tr>
								<td height="10"></td>
							</tr>
		                </table>
					</center>
				</div> 
			';
			
			return $block;
		}//SetHeaderBloc()
		
		/*Encapsulage des blocs centrés dans la news en pied de page pour la partie desabonnement*/
		function SetDesabonnementBloc(){
		
			$block ='
				<div align="center">
					<center>
						<table style="border-collapse:collapse; font-family:Arial; font-size:14px" border="0" cellpadding="0" cellspacing="0" width="'.$this->LARGEUR_NEWS.'">
							<tr>
								<td height="20"></td>
							</tr>
							<tr>
								<td style="font-family:Arial; text-align:center; font-size: 11px; color:#000">
		                            Conform&eacute;ment &agrave; la loi, vous disposez d\'un droit d\'acc&egrave;s et de rectification aux donn&eacute;es vous concernant.
		                            <br>
		                            <a style="color:#F90;" title="Se d&eacute;sinscrire" target="_blank" href="mailto:'.$this->desabonnement_mail.'?subject=D&eacute;sabonnement Newsletter Interne">
		                            	Cliquez ici
		                           	</a>, si vous ne d&eacute;sirez plus de messages de la part de '.SITE_NAME.'.
								</td>
							</tr>
							<tr>
								<td height="20"></td>
							</tr>
		                </table>
					</center>
				</div>
			';
			
			return $block;
		}//SetCenterBloc()
		
		/*Encapsulage du corps de la newsletter*/
		function SetCorpsNewsletterBloc($content){
			$block ='
				<div align="center">
			            <center>
							<table style="border:10px solid #545; font-family:Times New Roman, Arial, Helvetica, sans-serif; text-align: justify" cellpadding="0" cellspacing="0" width="'.$this->LARGEUR_NEWS.'">
								'.$content.'
							 </table>
					</center>
				</div> 
			';
			return $block;
		}//SetCorpsNewsletterBloc()
		
		//Pour afficher le contenu d'un fichier csv
		function Get_Csv($fichier){
			$row = 0;
			
			//si le fichier est présent (test ouverture)
			if (($fic = fopen($fichier, "r")) !== FALSE) {
					
				echo "Obtention du fichier CSV<br/>";
				
			    while (($data = fgetcsv($fic, 1024, ";")) !== FALSE){
			    	$bloc[$row] = $data;
					
					//ligne suivante du fichier csv
					$row++;
				}
				echo "Lecture du fichier CSV terminée<br/>";
				fclose($fic);
			}else{
				echo 'Le fichier '.$fichier.' est introuvable !<br/>';
			}
			//var_dump($bloc);
			return $bloc;
		}
		
		//Pour obtenir les contenu de la newsletter courante
		function Get_contents(){
			//il faut affecter les contenus appropriés
			//Avec l'id_newsletter récupérer les données du fichier .csv contenant tous les articles de la news courante
			
			$fichier = $this->url_news."articles.csv";
			$data = $this->Get_Csv($fichier);
			      
			//var_dump($data);
			//print_r($data);
			//echo count($data);
			//débute ligne 1 pour ne pas afficher les libellés des colonnes du csv
			for ($ligne=1;$ligne<count($data);$ligne++){
			
				$image_article 		= utf8_encode($data[$ligne][0]);
				$titre_article 		= utf8_encode($data[$ligne][1]);
				$contenu_article 	= utf8_encode($data[$ligne][2]);
				$lien_article	 	= utf8_encode($data[$ligne][3]);
				$auteur_article		= utf8_encode($data[$ligne][4]);
				
				//test si on a une image
				if($image_article!="")
					$curent_image_article = '
						<img style="display:block; border:4px solid #545; padding:1px" src="'.$this->url_img_news.$image_article.'" alt="" width="'.$this->TAILLE_IMG_NEWS.'" />
					';
				
				//test si lien
				if($lien_article!=""){
					//test si le lien conteine la chaine youtube
					if(preg_match("/youtube/i",$lien_article)){
						$curent_lien_article = '
							<a style="color:#F60;" target="_blank" href="'.$lien_article.'">
								<img style="border:0" src="'.$this->url_img_module.'btn_video.png" alt="Voir la démonstration en vidéo" />
							</a>
						';
					}else{
						$curent_lien_article = '
							<a style="color:#F60" target="_blank" href="'.$lien_article.'">
								<img style="border:0" src="'.$this->url_img_module.'btn_lien.png" alt="Voir sur internet" />
							</a>
						';
					}
				}
				// si auteur renseigné
				if($auteur_article!=""){
					$curent_auteur_article = $auteur_article;
				}else{
					$curent_auteur_article = 'Votre webmaster';
				}
			
				$block .= '
					<tr>
						<td valign="top">
							<table style="text-align: justify; border-bottom:1px solid #AAA" width="100%">
								<tr>
									<td style="color:#545; font-size:20px">
										<b>'.$titre_article.'</b>
									</td>
								</tr>
								<tr>
									<td valign="top">
										'.$curent_image_article.'
									</td>
								</tr>
								<tr>
									<td style="color:#545; font-size:16px">
										'.$contenu_article.'
									</td>
								</tr>
								<tr>
									<td style="color:#545; font-size:14px; padding-top:10px;" align=right>
										'.$curent_lien_article.'
									</td>
								</tr>
								<tr>
									<td height="2"></td>
								</tr>
								<tr>
									<td style="color:#999; font-size:10px" align=right>
										'.$curent_auteur_article.'
									</td>
								</tr>
								
							</table>
						<td>
					</tr>
					<tr>
						<td height="20"></td>
					</tr>
					
				';
				
				//réinitialise les bloc à vide pour la ligne suivante
				$curent_image_article 		= "";
				$titre_article 				= "";
				$contenu_article 			= "";
				$curent_lien_article	 	= "";
				$curent_auteur_article		= "";
				
			}
			return $block;
			//on vide le fichier à la sortie
			$fichier = '';
		}		
		
		function SetNewsletter(){

			$this->title_news = "La newsletter interne d'Immoventedirect International";		
			
			$this->body_news = '
				<tr>
					<td style="background:#545; color:#F90; font-size:12px; padding-top:5px; padding-right:10px" align="right">
						<i>'.$this->date_news.'</i>
					</td>
				</tr>
				<tr>
					<td style="background:#545" align="center">
						<img style="display:block; border:0" src="'.$this->url_img_module.'entete.jpg" alt="'.SITE_NAME.'" />
					</td>
				</tr>
				<!--header-->
				<tr>
					<td style="background:#545; color:#FFF; font-size:12px; padding:10px 40px;" align="left">
						<b style="color:#F60"><i>EDITO :</i></b> Retrouvez dans <i><b style="color:#F60">'.NEWSLETTER_IN_NAME.'</b></i>, l\'actualité interne ainsi que
						les nouveautés du site internet d\'<a target="_blank" style="color:#F90" href="'.URL_SITE.'" alt="'.SITE_NAME.'">'.SITE_NAME.'</a>.
					</td>
				</tr>
				<tr>
					<td style="padding:'.$this->LARGEUR_MARGE_NEWS.'px" align="center">
						
						<table style="margin-bottom:10px" cellpadding="0" cellspacing="0" width="100%">
							<tr>
								<td style="border-bottom:1px solid #F60; color:#F60; font-size:25px" align="left" colspan="2">
									Les nouveautés
								</td>
							</tr>
							<tr>
								<td height="10"></td>
							</tr>
							<!--articles-->
							'.$this->Get_contents().'
						</table>
					</td>
				</tr>
				<tr>
					<td style="background:#545; color:#FFF; font-size:12px; padding:10px; text-align:justify" align="center">
						<b>Suivez-nous sur internet :</b>
						<br/>
						<a style="text-decoration: none;" href="http://www.immoventedirect.com/">
							<img	style="border:0;"
									src="http://www.immoventedirect.com/signatures/img/picto_ivd.png"
									alt="Immoventedirect : Annonces immobili&egrave;res entre particuliers,
										en France et &agrave; l\'&eacute;tranger sans commission &agrave; la vente" />
						</a>
						<a style="text-decoration: none;" href="http://www.facebook.com/Immoventedirectinternational">
							<img style="border:0;" src="http://www.immoventedirect.com/signatures/img/picto_fb" alt="Facebook" />
						</a>
						<a style="text-decoration: none;" href="http://twitter.com/#!/immoventedirect/">
							<img style="border:0;" src="http://www.immoventedirect.com/signatures/img/picto_tt" alt="Twitter" />
						</a>
						<a style="text-decoration: none;" href="http://www.youtube.com/user/immoventedirect/">
							<img style="border:0;" src="http://www.immoventedirect.com/signatures/img/picto_yt" alt="YouTube" />
						</a>
						<a style="text-decoration: none;" href="http://www.dailymotion.com/immoventedirect/">
							<img style="border:0;" src="http://www.immoventedirect.com/signatures/img/picto_dm" alt="Dailymotion" />
						</a>
					</td>
				</tr>
				<!--footer-->
				<tr>
					<td height="20"></td>
				</tr>
				<tr>
					<td style="font-size:12px" align="center">
						<img style="display:block; border:0" src="'.$this->url_img_module.'immoventedirect.png" alt="Immoventedirect International" />
						<br>
						L’immobilier entre particuliers, en france et à l’étranger sans commission à la vente
					</td>
				</tr>
				<tr>
					<td height="20"></td>
				</tr>
				<tr>
					<td style="color:#F09; font-size:12px" align="center">
						<img style="display:block; border:0" src="'.$this->url_img_module.'numero_vert.png" alt="Numéro Vert" />
					</td>
				</tr>
				<tr>
					<td height="20"></td>
				</tr>
			';
			
			//si pas de demande de preview on affiche le lien "voir en ligne" et le desabonnement
			if(!isset($_GET["preview"])){
				//cas particulier du lien en ligne
				$bloc_apercuenligne = $this->SetPreviewBloc();
				//cas particulier du desabonnement
				$bloc_desabonnement = $this->SetDesabonnementBloc();
			}
			
			$block ='
				<html>
				'.$this->head.'
					<body style="margin:0; padding:0">
						'.$this->SetHeaderBloc().'
						'.$bloc_apercuenligne.'
						'.$this->SetCorpsNewsletterBloc($this->body_news).'
						'.$bloc_desabonnement.'
					<body>
				</html>
			';
			
			return $block;
		}//SetNewsletter()
		
		//************************************************************ FONCTIONS MESSAGES ECRAN ****//
		function AfficheMessageEnvoi(){
			$bloc ='
				<hr>
				<form action="'.URL_COURANTE.'" method="post">
					<input type="hidden" name="action" value="done" />
					<table border="0" cellpadding="2" cellspacing="2" align="center">						
						<tr>
							<td align="center">
								<a href="'.$this->url_admin_news.'">Retour &agrave; l\'administration</a>
							</td>
						</tr>
						<tr>
							<td align="center">
								Envoyer la newsletter : "'.$this->title_news.'" <small>('.$this->id_news.')</small> ?
								<input name="envoyer" type="submit" id="envoyer" value="Envoyer"/>
							</td>
						</tr>
					</table>
					<hr/>					
				</form>
			';
			
			return $bloc;
		}//AfficheMessageEnvoi()
		
		//************************************************************ FONCTIONS MESSAGES ECRAN ****//
		function AfficheMessageConfirmation(){
			$bloc =
				'
				<hr/>
					<table border="0" cellpadding="2" cellspacing="2" align="center">						
						<tr>
							<td align="center">
								<a href="'.$this->url_admin_news .'">Retour &agrave; l\'administration</a>
							</td>
						</tr>
						<tr>
							<td align="center">
								La newsletter "'.$this->title_news.'" <small>('.$this->id_news.')</small> a bien &eacute;t&eacute; envoy&eacute;e.
							</td>
						</tr>
					</table>
				<hr/>	
				';
	
			return $bloc;
		}//AfficheMessageConfirmation
		
		function Get_Liste_diffusion(){
				
			echo "Demande de la liste de diffusion : ".$fichier."<br/>";
			//$fichier = $this->url_admin_news."liste_de_diffusion.csv";
			$fichier = $this->url_news."liste_de_diffusion.csv";
			$data = $this->Get_Csv($fichier);
			//echo "Affichage des données :<br/>";
			//var_dump($data);
			
			echo count($data);
			//débute ligne 1 pour ne pas afficher les libellés des colonnes du csv
			for ($ligne=1;$ligne<count($data);$ligne++){
				//echo "data :".$data[$ligne][1];
								
				$prenom = utf8_encode($data[$ligne][0]);
				$email	= utf8_encode($data[$ligne][1]);
				//Mise en forme de la liste de diffusion
				$bloc .= $email;
				//$bloc .= $prenom.' <'.$email.'>';
				//echo "bloc :".$bloc;
				
				//Pour la virgule entre les contacts sauf pour le dernier
				//count($data)-1  car le premier rang meme s'il n'est pas affiché, est quand même compté. Il faut donc retirer 1. 
				if($ligne!=(count($data)-1)) $bloc .=', ';
			}
			var_dump($bloc);
			return $bloc;
		}
		
		function SendNewsletter($newsletter){
			
					
			//echo "Courante newsletter : ".COURANTE_Newsletter.'_NLI';
			//************************************************************ PROCESS NEWSLETTER ****//
			if(isset($_POST['action']) && $_POST['action'] == "done"){
				
				//**** PREPARATION ****//
				
				//$headers ='From: "'.SITE_NAME.'"<'.$mail_administrateur.'>'."\n";
				//$headers .='Content-Type: text/html; charset="UTF-8"'."\n";
				
				$mailTo = $this->mail_administrateur;
				
				// Pour envoyer un mail HTML, l'en-tête Content-type doit être défini
			   //$headers  = 'MIME-Version: 1.0'."\r\n";
			    $headers .= 'Content-type: text/html; charset=UTF-8'."\r\n";
			
				// En-têtes additionnels
			    //$headers .= 'To: Mary <mary@example.com>, Kelly <kelly@example.com>'."\r\n";
			    //$headers .= 'To: '.SITE_NAME.' <'.$this->mail_administrateur.'>'."\r\n";
			    $headers .= 'From: '.SITE_NAME.'<'.$this->mail_administrateur.'>'."\r\n";
			    //$headers .= 'Cc: '.$this->mail_administrateur.''."\r\n";
			    				
				/*
				if (LIST_DIFFUSION_MAIL!="")
			    	$headers .= 'Bcc: '.LIST_DIFFUSION_MAIL.''."\r\n";
				*/
				$objet = html_entity_decode($this->title_news);
				$bodyMail = $newsletter;
				
				
				//--------------
			
					//Connection();
				
					//$sql = 'SELECT '.MAIL_CONTACT.' FROM '.TABLE_CONTACT.' WHERE '.ABONEWSPRO_CONTACT.' = 1';
					//$result = mysql_query ($sql) or die ('Erreur SQL from listing mails ! '.$sql.'<br />'.mysql_error());
					
					//Resultat de requete en liste
					//while($row = mysql_fetch_assoc($result))
				    //{
					//   $mailTo = $row[MAIL_CONTACT];
					    //**** ENVOIE DE LA NEWSLETTER ****//
						 //Récupération de la liste de diffusion
					    $liste_de_diffusion = $this->Get_Liste_diffusion();
						
						if ($liste_de_diffusion!=""){
					    	$headers .= 'Bcc: '.$liste_de_diffusion.''."\r\n";
							echo 'Info - Liste de diffusion : '.$liste_de_diffusion.'<br/>';
							//Envoi du mail
							mail($mailTo, $objet, $bodyMail, $headers);
							echo 'Newsletter envoyée !<br/>';
						}else{
							echo 'Info - Liste de diffusion vide<br/>';
							echo 'Echec de l\'envoi de la newsletter<br/>';
						}
					    
				    //}
			
				   //$mailTo .=ADMINISTRATOR_MAIL;
				    
				    //Disconnect();
					
					//$mailTo = $destinataires;
					
				//--------------
				
				//Preparation du message de validation
				$message = $this->AfficheMessageConfirmation();
				//$message .= $newsletter;
				
			}else{
	
				$message .= $this->AfficheMessageEnvoi();
				$message .= $newsletter;
				
			}
			
			//**** MESSAGE ECRAN ****//
			echo $message;
		}
		
		
		function __destruct() {
		}
	}// class Site()
?>